# Low Level System Design

This project contains multiple LLD codes for system design interviews. <br/>
Please raise issues and pull requests for fixes and updates.

1. Cache
2. Event Bus
3. Rate Limiter
4. Service Orchestrator

The following resources are useful for learning low level design.

### Design Patterns

[Refactoring Guru](https://refactoring.guru/)

### Memory Management

[Texas University Memory Models](https://www.cs.utexas.edu/~bornholt/post/memory-models.html)

[Slack reducing memory footprint](https://slack.engineering/reducing-slacks-memory-footprint)

### Rate Limiting

[Apache Kafka Exactly Once processing](https://docs.google.com/document/d/11Jqy_GjUGtdXJK94XGsEIK7CP1SnQGdp2eF0wSw9ra8)

[Uber Rate Limiter](https://github.com/uber-go/ratelimit/blob/master/ratelimit.go)

[Martin Fowler Circuit Breaker](https://martinfowler.com/bliki/CircuitBreaker.html)

[Netflix Hystrix](https://github.com/Netflix/Hystrix)

[Amazon AWS Shuffle Sharding](https://github.com/awslabs/route53-infima)

### Course 

https://interviewready.io/
